# template for PSet #3, Python Task #2
import numpy
import matplotlib.pyplot as p
import PS3_tests
from PS3_1 import unit_sample_response

# create some plots showing how prediction of the
# response using the convolution sum compares with
# the actual response from the channel.
def compare_usr_chan(channel,samples_per_bit):
    # Get channel's unit sample response
    h = unit_sample_response(channel)

    # send test message through channel
    bits = [1,0,1,0,1,0,1,0]
    test_samples = PS3_tests.transmit(bits,samples_per_bit)
    out_samples = channel(test_samples)

    # make prediction of result using unit-sample response
    out_conv_samples = numpy.convolve(numpy.array(test_samples),
                                      numpy.array(h))

    # only compare as many samples as in the shortest output
    num_compare = min(len(out_samples),len(out_conv_samples))
    out_conv_samples = out_conv_samples[:num_compare] 
    out_samples = out_samples[:num_compare]
    
    # plot the results
    max_ot = max([max(test_samples),
                  max(out_samples),
                  max(out_conv_samples)])
    min_ot = min([min(test_samples),
                  min(out_samples),
                  min(out_conv_samples)])
    delta = max_ot - min_ot
    plot_max = max_ot + 0.1 * delta  # avoid samples at the edges of plot
    plot_min = min_ot - 0.1 * delta

    p.figure()
    p.subplots_adjust(hspace = 0.6)
    cname = "Channel " + channel.id

    p.subplot(311)
    p.plot(out_samples)
    p.title(cname+" Output")
    p.axis([0,num_compare,plot_min,plot_max])

    p.subplot(312)
    p.plot(out_conv_samples)
    p.title(cname+" Prediction")
    p.axis([0,num_compare,plot_min,plot_max])

    p.subplot(313)
    p.plot(out_conv_samples - out_samples)
    p.title(cname+" Error")

if __name__ == '__main__':
    # plot the unit-sample response of our two channels
    compare_usr_chan(PS3_tests.channel('1'),100)
    compare_usr_chan(PS3_tests.channel('2'),50)

    # interact with plots before exiting.
    p.show()  
