import math
import cmath
import matplotlib.pyplot as p
import PS8_tests
from PS2_1 import data_recovery
from PS2_2 import receive_8b10b

# return digitized samples from the frequency band centered at kdemod.
def quadrature_demod(samples,kdemod,kcutoff):
        #TA: samples are time based with 3 signals modulated together

        N = len(samples)
        #print samples[1:100]

##        #try some gain
##        samplesg = []
##        for n in range(0, N):
##                samplesg.append(samples[n]*1000000)
##
##        print samplesg[1:100]
        

        #go through each time step and multiply by sin and cos
        samples_cos = []
        samples_sin = []
        for n in range(0,N):
                samples_cos.append(math.cos((kdemod*2*math.pi)/N*n)*samples[n])
                samples_sin.append(math.sin((kdemod*2*math.pi)/N*n)*samples[n])

##        #convert to freq
##        aks_cos = PS8_tests.fast_frequency_domain(samples_cos)
##        aks_sin = PS8_tests.fast_frequency_domain(samples_sin)
##
##        #print aks_cos
##
##        #low pass filter
##        #want to filter out middle +- kcutoff
##        #but list is 0 indexed
##        aks_cos_cut = PS8_tests.band_limit(aks_cos,kcutoff)
##        aks_sin_cut = PS8_tests.band_limit(aks_sin,kcutoff)
##
##        #convert back to time
##        I = PS8_tests.fast_time_domain(aks_cos_cut)
##        Q = PS8_tests.fast_time_domain(aks_sin_cut)

        #band limits does conversion for you!!
        I = PS8_tests.band_limit(samples_cos,kcutoff)
        Q = PS8_tests.band_limit(samples_sin,kcutoff)

        #need new N
        N=len(I)

        #print I[1:100]
        #print Q[1:100]
        
        #demodulate
        w = []
        for n in range(0, N):
                w.append(math.sqrt(I[n]*I[n]+Q[n]*Q[n]))

        print w[1:100]

        #digitize
        #find avg value of it
        avg = float(sum(w)) / len(w)
        print avg
        bits = []
        for n in range(0, N):
                if w[n] >= avg:
                        bits.append(1)
                else:
                        bits.append(0)

        #done
        return bits
                


# read in samples for the shared channel
samples = PS8_tests.read_wav_file('PS8_rf.wav')

# take a look at the spectrum we received
#p.figure()
#PS8_tests.plot_spectrum_magnitude(samples)
#p.title('$|a_k|$ for received signal')
#p.show()

# recover one of the messages by demodulating the appropriate
# piece of the spectrum down to baseband.
#first one
kdemod = 1000
#plus or minus around center
kcutoff = 500
digitized_samples = quadrature_demod(samples,kdemod,kcutoff)
print digitized_samples[1:500]

# recover bits from digitized samples
samples_per_bit = 20
bits = data_recovery(digitized_samples,samples_per_bit)

# decode 8b10b-encoded packets
msg = receive_8b10b(bits)

# print result!
print msg

kdemod = 2000
#plus or minus around center
kcutoff = 500
digitized_samples = quadrature_demod(samples,kdemod,kcutoff)
print digitized_samples[1:500]

# recover bits from digitized samples
samples_per_bit = 20
bits = data_recovery(digitized_samples,samples_per_bit)

# decode 8b10b-encoded packets
msg = receive_8b10b(bits)

# print result!
print msg


kdemod = 3000
#plus or minus around center
kcutoff = 500
digitized_samples = quadrature_demod(samples,kdemod,kcutoff)
print digitized_samples[1:500]

# recover bits from digitized samples
samples_per_bit = 20
bits = data_recovery(digitized_samples,samples_per_bit)

# decode 8b10b-encoded packets
msg = receive_8b10b(bits)

# print result!
print msg

